searchNodes=[{"doc":"RPC client and server. MeshxRpc can be considered as an alternative to Erlang OTP :erpc or :rpc modules. Major differences between MeshxRpc and native :erpc modules: MeshxRpc is using custom binary communication protocol, hence it doesn't depend on Erlang distribution and can be used with any user provided TCP transport solution, especially service mesh data plane, MeshxRpc restricts incoming request function executability scope to single module associated with given RPC server. This way user has full control over RPC server functionality exposed to remote RPC clients, instead of allowing unrestricted access to remote as it is a case for OTP :erpc module. MeshxRpc features: connection pooling, user customizable serialization functions, traffic chunking into smaller blocks of configurable maximum size to avoid IO socket blocking, optional transmission error detection with user configurable asynchronously executed message block checksum functions, reach per request telemetry metrics, request integrity protection with sequence numbers and node/connection references, primitive access control with optional preshared keys, load balancing and high availability provided by service mesh data plane, ability to run multiple RPC servers and/or clients on a single node. MeshxRpc is designed to work primarily as mesh service and doesn't offer data encryption, authorization or authentication mechanisms as those are natively provided by service mesh environment. Installation Add :meshx_rpc and optionally :meshx_consul , :ranch and :poolboy to application dependencies: # mix.exs def deps do [ { :meshx_rpc , &quot;~&gt; 0.1.0&quot; } , # if using :meshx_consul service mesh adapter add: { :meshx_consul , &quot;~&gt; 0.1.0&quot; } , # if running RPC client(s) add: { :poolboy , &quot;~&gt; 1.5&quot; } , # if running RPC server(s) add: { :ranch , &quot;~&gt; 2.0&quot; } ] end Usage Same mix project is used to implement both RPC server and RPC client to simplify examples. Server and client nodes are started using custom command line argument rpc_server? : start server: iex --erl &quot;-rpc_server? true&quot; , start client: iex --erl &quot;-rpc_server? false&quot; . Example 1. Shared Unix Domain Socket. Implement RPC server Example1.Server and client Example1.Client modules: # lib/server.ex defmodule Example1.Server do use MeshxRpc.Server , address : { :uds , &quot;/tmp/meshx.sock&quot; } , telemetry_prefix : [ :example1 , __MODULE__ ] def echo ( args ) , do : args def ping ( _args ) , do : :pong end # lib/client.ex defmodule Example1.Client do use MeshxRpc.Client , address : { :uds , &quot;/tmp/meshx.sock&quot; } , telemetry_prefix : [ :example1 , __MODULE__ ] , pool_opts : [ size : 1 , max_overflow : 0 ] def echo ( args ) , do : call ( :echo , args ) end Both client and server connect to the same UDS socket at &quot;/tmp/meshx.sock&quot; . For RPC client number of pool workers is limited to one, to reduce amount of telemetry events logged to terminal. RPC client and server are started using application supervision tree by using their respective child specifications Example1.Client.child_spec() and Example1.Server.child_spec() : # lib/example1/application.ex defmodule Example1.Application do use Application @impl true def start ( _type , _args ) do children = if rpc_server? ( ) do MeshxRpc . attach_telemetry ( [ :example1 , Example1.Server ] ) [ Example1.Server . child_spec ( ) ] else MeshxRpc . attach_telemetry ( [ :example1 , Example1.Client ] ) [ Example1.Client . child_spec ( ) ] end Supervisor . start_link ( children , strategy : :one_for_one , name : Example1.Supervisor ) end defp rpc_server? ( ) do case :init . get_argument ( :rpc_server? ) do { :ok , [ [ &#39;true&#39; ] ] } -&gt; true _ -&gt; false end end end Launch two terminals, start RPC server node in first terminal: iex --erl &quot;-start_epmd false&quot; --erl &quot;-rpc_server? true&quot; -S mix Start RPC client node in second terminal: iex --erl &quot;-start_epmd false&quot; --erl &quot;-rpc_server? false&quot; -S mix In both terminals similar telemetry event should be logged, here client side: # [:example1, Example1.Client, :hsk] -&gt; :ok # local: %{conn_ref: &quot;VPRihQ&quot;, node_ref: &quot;nonode@nohost&quot;, svc_ref: &quot;Elixir.Example1.Client&quot;} # remote: %{conn_ref: &quot;wfyMQQ&quot;, node_ref: &quot;nonode@nohost&quot;, svc_ref: &quot;Elixir.Example1.Server&quot;} # ... First line says that successful handshake ( :hsk ) was executed by [:example1, Example1.Client] . Next two log lines describe local and remote endpoints. Please check MeshxRpc.attach_telemetry/2 for details. Execute RPC requests in client terminal: # telemetry events removed iex(1)&gt; Example1.Client . call ( :ping ) :pong iex(2)&gt; Example1.Client . echo ( &quot;hello world&quot; ) &quot;hello world&quot; iex(3)&gt; Example1.Client . cast ( :echo , &quot;hello world&quot; ) :ok When using OTP :erpc module it is possible to execute arbitrary function call on remote node, for example: :erpc.call(:other_node, File, :rm, [&quot;/1/etc/*.remove_all&quot;]) . As mentioned earlier request execution scope in MeshxRpc is limited to single server module, here Example1.Server exposes only ping/1 and echo/1 functions. Requesting execution of not implemented (or not allowed) remote function will result in error: iex(3)&gt; Example1.Client . call ( :rm , [ &quot;/1/etc/*.remove_all&quot; ] ) { :error_rpc , { :undef , [ ... ] } } Possible extension to this example could be: run RPC server and client nodes on different hosts and connect UDS sockets using ssh port forwarding. Example 2. Service mesh using MeshxConsul . Please check MeshxConsul package documentation for additional requirements and configuration steps necessary when using Consul service mesh adapter. Starting user service providers and upstream clients connected to service mesh requires interaction with Consul used as external service mesh application. Running external API calls that can block, during supervision tree initialization is considered as bad practice. To start mesh service provider and mesh upstream client asynchronously, additional DynamicSupervisor will be created. First implement RPC server Example2.Server and client Example2.Client modules: # lib/server.ex defmodule Example2.Server do use MeshxRpc.Server , telemetry_prefix : [ :example2 , __MODULE__ ] def echo ( args ) , do : args def ping ( _args ) , do : :pong end # lib/client.ex defmodule Example2.Client do use MeshxRpc.Client , telemetry_prefix : [ :example2 , __MODULE__ ] , pool_opts : [ size : 1 , max_overflow : 0 ] def echo ( args ) , do : call ( :echo , args ) end Dynamic supervisor managing mesh services is named Example2.MeshSupervisor and started using application supervisor: # lib/example2/application.ex defmodule Example2.Application do use Application @impl true def start ( _type , _args ) do Supervisor . start_link ( [ Example2.MeshSupervisor ] , strategy : :one_for_one , name : Example2.Supervisor ) end end Dynamic supervisor Example2.MeshSupervisor will asynchronously start both RPC server and client depending on --erl &quot;-rpc_server? true/false&quot; command line argument: # lib/mesh_supervisor.ex defmodule Example2.MeshSupervisor do use DynamicSupervisor def start_link ( init_arg ) , do : DynamicSupervisor . start_link ( __MODULE__ , init_arg , name : __MODULE__ ) @impl true def init ( _init_arg ) do spawn ( __MODULE__ , :start_mesh , [ ] ) DynamicSupervisor . init ( strategy : :one_for_one ) end def start_mesh ( ) do child = if rpc_server? ( ) do MeshxRpc . attach_telemetry ( [ :example2 , Example2.Server ] ) { :ok , _id , address } = MeshxConsul . start ( &quot;service-1&quot; ) Example2.Server . child_spec ( address : address ) else MeshxRpc . attach_telemetry ( [ :example2 , Example2.Client ] ) { :ok , [ { :ok , address } ] } = MeshxConsul . connect ( [ &quot;service-1&quot; ] ) Example2.Client . child_spec ( address : address ) end DynamicSupervisor . start_child ( __MODULE__ , child ) end defp rpc_server? ( ) do case :init . get_argument ( :rpc_server? ) do { :ok , [ [ &#39;true&#39; ] ] } -&gt; true _ -&gt; false end end end Commands to start server and client nodes are same as in Example 1 . When RPC server node is started mesh service endpoint address is prepared by running MeshxConsul.start(&quot;service-1&quot;) function: mesh service &quot;service-1&quot; is registered with Consul service registry, required by service &quot;service-1&quot; workers are stared, including sidecar proxy connecting &quot;service-1&quot; with Consul managed mesh data plane. Next DynamicSupervisor starts child specified with Example2.Server.child_spec(address: address) . Started child worker is a user defined (RPC) server attached to mesh service endpoint address , hence it becomes user mesh service provider that can be: accessed by remote mesh upstream clients, managed using Consul service mesh control plane. When RPC client node is started mesh upstream endpoint address is prepared by MeshxConsul.connect(&quot;service-1&quot;) : special &quot;proxy service&quot; is registered with Consul, default service name is prefix &quot;upstream-&quot; concatenated with host name; in this example it is &quot;upstream-h11&quot; , upstream &quot;service-1&quot; is added to sidecar proxy service &quot;upstream-h11&quot; , required by proxy service &quot;upstream-h11&quot; workers are stared, including sidecar proxy connecting &quot;upstream-h11&quot; with mesh data plane. Next DynamicSupervisor starts child specified with Example2.Client.child_spec(address: address) . Started child worker is a user defined (RPC) client attached to mesh upstream endpoint address , hence it becomes user mesh upstream client connected to service mesh data plane. Consul UI screenshot showing connection between upstream-h11 proxy service and service-1 : Common configuration RPC client and server modules provide child specifications which should be used with user supervisors as shown on examples above. RPC client child_spec can be created directly by accessing MeshxRpc.Client.Pool.child_spec/2 or by using wrapper module MeshxRpc.Client . Similarly RPC server child_spec is available through MeshxRpc.Server.Pool.child_spec/2 or MeshxRpc.Server modules. Configuration options common to client and server child_spec/2 functions: :pool_opts - worker pool options for RPC client and server. Server pool is build using ranch socket acceptor pool . pool_opts correspond in this case to ranch transport options . Client pool is build using poolboy , pool_opts correspond here directly to poolboy options . Users usually should not set any pool_opts for server pools. Options that can be set for RPC client pools: :size - maximum pool size, default 10, :max_overflow - maximum number of workers created if pool is empty, :strategy - :lifo or :fifo , determines whether checked in workers should be placed first or last in the line of available workers. So, :lifo operates like a traditional stack; :fifo like a queue. Default is :lifo . The default value is [] . :address - Required. Address on which server will listen for requests or client will send requests to. Two address types are supported: ethernet interface address: {:tcp, ip, port} , where ip is defined as tuple (e.g. {127, 0, 0, 1} ) and port is integer in the range 1..65535 , Unix Domain Socket address: {:uds, path} , where socket path is defined as string, e.g. {:uds, &quot;/tmp/beam.sock&quot;} :blk_max_size - user request function arguments are first serialized into binary using function specified with :serialize_mfa option. Binary is then split into smaller blocks send over the wire. Option defines maximum send block byte size. Must be between 200 bytes and 256 MB ( 200..268_435_456 ). The default value is 16384 . :cks_mfa - block checksum function {module, function, argument} . 2-arity function accepting: 1st argument - binary data to calculate checksum, 2nd argument - as set in option argument . Function result should be calculated checksum of binary() type. Example checksum implementation is MeshxRpc.Protocol.Default.checksum/2 , using :erlang.crc32/1 . To use this function set: [cks_mfa: {MeshxRpc.Protocol.Default, :checksum, []}] . If option is left undefined checksums are not calculated. The default value is nil . :conn_ref_mfa - {module, function, argument} function generating connection reference, 0-arity. The default value is {MeshxRpc.Protocol.Default, :conn_ref, []} . :deserialize_mfa - {module, function, argument} function used to de-serialize request argument, 3-arity. Function should reverse data serialization process executed by function specified by :serialize_mfa . First function argument is binary data to de-serialize, second is option argument , third is serialization flag generated by :serialize_mfa . Function should return {:ok, deserialized} if successful, {:error, reason} otherwise. The default value is {MeshxRpc.Protocol.Default, :deserialize, []} . :hsk_dgt_mfa - {module, function, argument} function used to calculate digest in connection handshake, 2-arity. First argument is binary data for which digest should be calculated, second is option argument . The default value is {MeshxRpc.Protocol.Default, :checksum, []} . :node_ref_mfa - {module, function, argument} function generating request node reference, 0-arity. The default value is {MeshxRpc.Protocol.Default, :node_ref, []} . :quiet_on_hsk_error? - when connection is established between RPC server and client first step is a two-way handshake. If handshake fails remote node can be notified about failure or failure can be silently discarded. The default value is false . :serialize_mfa - {module, function, argument} function used to serialize user request function argument(s), 2-arity. First argument is erlang term that requires serialization, second is option argument . Function should return if successful {:ok, serialized_binary, serialization_flag} . serialization_flag should be one byte integer ( 0..255 ). It states how data should be de-serialized and will be passed as third argument to function specified in :deserialize_mfa . In case of error function should return {:error, reason} . The default value is {MeshxRpc.Protocol.Default, :serialize, []} . :shared_key - shared key must be same for connecting server and client. Can be used to specify for example API version: shared_key: &quot;api_ver_01&quot; . The default value is &quot;&quot; . :socket_opts - connection socket options. Check :inet.setopts/2 for available settings. The default value is [] . :svc_ref_mfa - {module, function, argument} function generating request service reference, 0-arity. If not defined, by default service reference will be calculated from: service_id |&gt; to_string() |&gt; String.slice(0..255) . :telemetry_prefix - specifies prefix used when executing telemetry events. If not defined package name and service module will be used, e.g.: [:meshx_rpc, MyApp.Rpc.Server1] . :timeout_hsk - handshake timeout. The default value is 5000 . :timeout_cks - timeout for function calculating block checksums specified by :cks_mfa . The default value is 500 . :gen_statem_opts - option passed as third argument to :gen_statem.start_link/3 when starting RPC server or client pool worker. The default value is [] . Telemetry Telemetry events Telemetry event prefix is defined with :telemetry_prefix configuration option. Events generated by MeshxRpc : :init - emitted only by server when server worker cannot establish socket connection with user provided address terminated with transport solution (e.g. service mesh sidecar proxy), :hsk - emitted by both server and client during connection handshake phase, :idle - emitted only by client workers when worker is in idle state waiting for user requests, :recv and :send - emitted by both client and server workers if there was a problem when receiving or sending request data, :call and :cast - emitted by client and server during failed or after successful call/cast request processing. Telemetry metadata :address - connection address, e.g. {:tcp, {127, 0, 0, 1}, 1024} , :fun_name - request function name, e.g. :echo , :fun_req - request function type, can be :call or :cast , :hsk_ref - handshake reference, integer() , :id - RPC server or client id, e.g. Example2.Client , :local - map describing local endpoint using keys: conn_ref , node_ref and svc_ref . :remote - as :local but for remote endpoint, :req_ref - request reference, integer() , :result - execution result. If request execution was successful :result is set to atom :ok , real execution results are not emitted by telemetry. If execution failed, error reason is emitted, :socket - socket port used in connection, e.g. #Port&lt;0.19&gt; , :state - worker :gen_statem last state, e.g. :reply . Example request telemetry metadata: %{ address : { :tcp , { 127 , 0 , 0 , 1 } , 65535 } , fun_name : :echo , fun_req : :cast , hsk_ref : 3490 , id : Example2.Client , local : %{ conn_ref : &lt;&lt; 123 , 219 , 9 , 168 &gt;&gt; , node_ref : &quot;nonode@nohost&quot; , svc_ref : &quot;Elixir.Example2.Client&quot; } , remote : %{ conn_ref : &lt;&lt; 66 , 9 , 108 , 5 &gt;&gt; , node_ref : &quot;nonode@nohost&quot; , svc_ref : &quot;Elixir.Example2.Server&quot; } , req_ref : 3650 , result : :ok , socket : # Port &lt; 0.12863 &gt; , state : :reply } Telemetry metrics Three metrics types are reported: :blocks - reports number of blocks, send and received, :size - number of bytes, send and received, :time - approximate time in microseconds spend on consecutive request processing steps. :time metrics: :ser and :dser - serialization and de-serialization time, :exec - request function execution time, :hsk - handshake time, :idle - worker idle time, :recv and :send - time spent on request data receiving and sending. Example telemetry metrics: %{ blocks : %{ recv : 1 , send : 1 } , size : %{ recv : 14 , send : 40 } , time : [ dser : 0 , exec : 1038 , hsk : 0 , idle : 101101 , recv : 12 , send : 102 , ser : 1 ] }","ref":"MeshxRpc.html","title":"MeshxRpc","type":"module"},{"doc":"Attaches pretty-printing Logger handler to telemetry events. First argument should correspond to :telemetry_prefix configuration option described earlier. Second argument is telemetry handler id . If handler id is undefined it will be assigned value equal to second list element in telemetry_prefix . Errors are logged with :error Logger level, all other events are logged with :debug level. Example log of :ping call request: Example2.Client . call ( :ping ) 12 : 17 : 11.869 [ debug ] [ :example2 , Example2.Client , :call , :ping ] -&gt; :ok local : %{ conn_ref : &quot;e9sJqA&quot; , node_ref : &quot;nonode@nohost&quot; , svc_ref : &quot;Elixir.Example2.Client&quot; } remote : %{ conn_ref : &quot;QglsBQ&quot; , node_ref : &quot;nonode@nohost&quot; , svc_ref : &quot;Elixir.Example2.Server&quot; } address : { :tcp , { 127 , 0 , 0 , 1 } , 65535 } meta : [ hsk_ref : 4034 , req_ref : 4066 , socket : # Port &lt; 0.14455 &gt; , state : :reply ] t_req : 2.152 [ dser : 0.006 , exec : 2.002 , recv : 0.036 , send : 0.105 , ser : 0.003 ] t_idle : 17547.272 size : [ recv : &quot;31B&quot; , send : &quot;31B&quot; ] blocks : [ recv : 1 , send : 1 ] t_req is a total request time followed by [individual request steps times], milliseconds. t_idle is a worker idle time, milliseconds. attach_telemetry/2 is created as helper for use during development phase, most probably should not be used in production.","ref":"MeshxRpc.html#attach_telemetry/2","title":"MeshxRpc.attach_telemetry/2","type":"function"},{"doc":"Convenience module on top of MeshxRpc.Client.Pool . Module leverages Kernel.use/2 macro to simplify user interaction with MeshxRpc.Client.Pool module: current module name is used as pool id, pool options can be specified with use/2 clause. Please refer to MeshxRpc.Client.Pool documentation for details. Example RPC client module: # lib/client.ex defmodule Example1.Client do use MeshxRpc.Client , address : { :tcp , { 127 , 0 , 0 , 1 } , 12_345 } , telemetry_prefix : [ :example1 , __MODULE__ ] , pool_opts : [ size : 20 , max_overflow : 5 ] , idle_reconnect : 60 * 60 * 1000 def echo ( args ) , do : call ( :echo , args ) end Start with application supervisor: # lib/example1/application.ex def start ( _type , _args ) do Supervisor . start_link ( [ Example1.Client ] , strategy : :one_for_one , name : Example1.Supervisor ) end Run RPC calls: iex(1)&gt; Example1.Client . echo ( &quot;hello world&quot; ) &quot;hello world&quot; iex(2)&gt; Example1.Client . call ( :echo , &quot;hello world&quot; ) &quot;hello world&quot; iex(3)&gt; MeshxRpc.Client.Pool . call ( Example1.Client , :echo , &quot;hello world&quot; ) &quot;hello world&quot;","ref":"MeshxRpc.Client.html","title":"MeshxRpc.Client","type":"behaviour"},{"doc":"Makes a synchronous RPC call request to the server and waits for its reply.","ref":"MeshxRpc.Client.html#c:call/5","title":"MeshxRpc.Client.call/5","type":"callback"},{"doc":"Same as call/5 , will reraise remote exception locally.","ref":"MeshxRpc.Client.html#c:call!/5","title":"MeshxRpc.Client.call!/5","type":"callback"},{"doc":"Sends an asynchronous RPC cast request to the server.","ref":"MeshxRpc.Client.html#c:cast/5","title":"MeshxRpc.Client.cast/5","type":"callback"},{"doc":"Returns a specification to start a RPC client workers pool under a supervisor.","ref":"MeshxRpc.Client.html#c:child_spec/1","title":"MeshxRpc.Client.child_spec/1","type":"callback"},{"doc":"RPC client workers pool. Configuration RPC client pool is configured with opts argument in child_spec/2 function. Configuration options common to both RPC client and server are described in MeshxRpc &quot;Common configuration&quot; section. Configuration options specific to RPC client opts argument in child_spec/2 : :idle_reconnect - after RPC client-server connection is established or after RPC request processing, client worker enters idle state waiting for the next user request. :idle_reconnect specifies amount of idle time after which client should reestablish connection. One can think about this feature as high level TCP keep-alive/heartbeat action. The default value is 600000 . :retry_idle_error - amount of time RPC client worker should wait before reconnecting after connection failure when in idle state. The default value is 1000 . :retry_hsk_fail - amount of time RPC client worker should wait before reconnecting after handshake failure. Most common handshake failure reason probably will be inconsistent client/server configuration, for example different :shared_key option on client and server. The default value is 5000 . :retry_proxy_fail - amount of time RPC client worker should wait before retrying reconnect to :address after initial socket connection failure. If :address points to mesh upstream endpoint proxy address, failures here can be associated with proxy binary problem. The default value is 1000 . :timeout_connect - timeout used when establishing initial TCP socket connection with RPC server. The default value is 5000 . :exec_retry_on_error - list of request processing errors on which request execution should be retried. The default value is [:closed, :tcp_closed] . Values for options prefixed with :retry- and :idle_reconnect are randomized by +/-10% . Unit for time related options is millisecond.","ref":"MeshxRpc.Client.Pool.html","title":"MeshxRpc.Client.Pool","type":"module"},{"doc":"Makes a synchronous RPC call request using workers pool and waits for reply. If successful, call/6 returns Kernel.apply(RpcServerMod, request, args) evaluation result on remote server. If error occurs during request processing {:error_rpc, reason} is returned. User defined RPC server functions should not return results as tuples with first tuple element being :error_rpc or any atom name starting with :error_rpc (for example :error_rpc_remote ) as those tuples are reserved by MeshxRpc internally for error reporting and processing. Possible request processing errors: :full - all client pool workers are busy and pool manager cannot checkout new worker, :killed - process executing request on remote server was killed because function execution time exceeded allowed timeout (see MeshxRpc.Server.Pool option :timeout_execute ), :invalid_cks - checksum check with user provided checksum function ( :cks_mfa option) failed, :timeout_cks - checksum calculation timeout, :closed - client worker received user request before handshake with server was completed, :tcp_closed - TCP socket connection was closed, :invalid_ref - request message failed referential integrity check, {:undef, [...]} - request function not defined on server, :invalid_state - server or client worker encountered inconsistent critical state, any :inet POSIX Error Codes , any errors from (de)serialization function. If remote server does not respond within time specified by timeout argument, process executing RPC call is killed, the function call fails and the caller exits. Additionally connection to remote server is closed which kills corresponding RPC call process being executed on the server. Please be aware of MeshxRpc.Server.Pool :timeout_execute configuration option playing similar role to timeout function argument on the server side. If error occurs during request processing and error reason is in list defined by :exec_retry_on_error configuration option, request will be retried retry times with randomized exponential back-off starting with retry_sleep msec. Example: iex(1)&gt; MeshxRpc.Client.Pool . call ( Example1.Client , :echo , &quot;hello world&quot; ) &quot;hello world&quot; iex(2)&gt; MeshxRpc.Client.Pool . call ( Example1.Client , :not_existing , &quot;hello world&quot; ) { :error_rpc , { :undef , [ ... ] } }","ref":"MeshxRpc.Client.Pool.html#call/6","title":"MeshxRpc.Client.Pool.call/6","type":"function"},{"doc":"Same as call/6 , will reraise remote exception locally. Example: iex(1)&gt; MeshxRpc.Client.Pool . call ( Example1.Client , :raise_test , &quot;raise kaboom!&quot; ) { :error_rpc , % RuntimeError { message : &quot;raise kaboom!&quot; } } iex(2)&gt; MeshxRpc.Client.Pool . call! ( Example1.Client , :raise_test , &quot;raise kaboom!&quot; ) ** (RuntimeError) raise kaboom!","ref":"MeshxRpc.Client.Pool.html#call!/6","title":"MeshxRpc.Client.Pool.call!/6","type":"function"},{"doc":"Sends an asynchronous RPC cast request using workers pool . Function always immediately returns :ok , even if pool doesn't exist or any other error takes place. args , timeout , retry and retry_sleep function arguments have the same meaning as in case of call/6 . Example: iex(1)&gt; MeshxRpc.Client.Pool . cast ( NotExisting , :undefined , [ ] ) :ok","ref":"MeshxRpc.Client.Pool.html#cast/6","title":"MeshxRpc.Client.Pool.cast/6","type":"function"},{"doc":"Returns a specification to start a RPC client workers pool under a supervisor. id is a pool id which might be a name of a module implementing user RPC functions. opts are options described in &quot;Configuration&quot; section above and in MeshxRpc &quot;Common configuration&quot; section. Example: iex(1)&gt; MeshxRpc.Client.Pool . child_spec ( Example1.Client , address : { :uds , &quot;/tmp/meshx.sock&quot; } ) { Example1.Client , { :poolboy , :start_link , [ [ name : { :local , Example1.Client } , worker_module : MeshxRpc.Client.Worker ] , [ ... ] ] } , :permanent , 5000 , :worker , [ :poolboy ] }","ref":"MeshxRpc.Client.Pool.html#child_spec/2","title":"MeshxRpc.Client.Pool.child_spec/2","type":"function"},{"doc":"","ref":"MeshxRpc.Client.Pool.html#retry_request/8","title":"MeshxRpc.Client.Pool.retry_request/8","type":"function"},{"doc":"RPC protocol default functions.","ref":"MeshxRpc.Protocol.Default.html","title":"MeshxRpc.Protocol.Default","type":"module"},{"doc":"Calculates checksum for given data with :erlang.crc32/1 . Function returns checksum as 4 bytes binary big endian unsigned integer. iex(1)&gt; MeshxRpc.Protocol.Default . checksum ( &quot;test&quot; , [ ] ) &lt;&lt; 216 , 127 , 126 , 12 &gt;&gt;","ref":"MeshxRpc.Protocol.Default.html#checksum/2","title":"MeshxRpc.Protocol.Default.checksum/2","type":"function"},{"doc":"Returns connection reference as 4 bytes random binary. iex(1)&gt; MeshxRpc.Protocol.Default . conn_ref ( ) &lt;&lt; 171 , 248 , 41 , 163 &gt;&gt; iex(2)&gt; MeshxRpc.Protocol.Default . conn_ref ( ) |&gt; Base . encode64 ( padding : false ) &quot;IKWzCw&quot;","ref":"MeshxRpc.Protocol.Default.html#conn_ref/0","title":"MeshxRpc.Protocol.Default.conn_ref/0","type":"function"},{"doc":"De-serializes given bin to Erlang term with :erlang.binary_to_term/2 . Function performs reverse operation to serialize/2 . If serialization_flag is 0 de-serialization step is skipped and function returns {:ok, bin} . Otherwise bin is de-serialized using :erlang.binary_to_term/2 . opts is passed as second argument to :erlang.binary_to_term/2 . serialize/2 provides usage example.","ref":"MeshxRpc.Protocol.Default.html#deserialize/3","title":"MeshxRpc.Protocol.Default.deserialize/3","type":"function"},{"doc":"Returns node reference as Node.self() converted to string with length limited to 255 characters. iex(1)&gt; MeshxRpc.Protocol.Default . node_ref ( ) &quot;nonode@nohost&quot;","ref":"MeshxRpc.Protocol.Default.html#node_ref/0","title":"MeshxRpc.Protocol.Default.node_ref/0","type":"function"},{"doc":"Serializes given Erlang term to binary with :erlang.term_to_binary/2 . If successful function returns serialized binary as result and serialization_flag . If user provided term is of binary type, serialization step is skipped and serialization_flag is set to 0 . Otherwise :erlang.term_to_binary(term, opts) is called and serialization_flag is set to 1 . Function argument opts is passed as options to :erlang.term_to_binary/2 . Serialization options can be used to force binary data compression, which by default is disabled. iex(1)&gt; { :ok , bin , ser_flag } = MeshxRpc.Protocol.Default . serialize ( %{ test_k : &quot;test_v&quot; } , [ ] ) { :ok , &lt;&lt; 131 , 116 , 0 , 0 , 0 , 1 , 100 , 0 , 6 , 116 , 101 , 115 , 116 , 95 , 107 , 109 , 0 , 0 , 0 , 6 , 116 , 101 , 115 , 116 , 95 , 118 &gt;&gt; , 1 } iex(2)&gt; MeshxRpc.Protocol.Default . deserialize ( bin , [ ] , ser_flag ) { :ok , %{ test_k : &quot;test_v&quot; } } iex(3)&gt; { :ok , bin , ser_flag } = MeshxRpc.Protocol.Default . serialize ( &quot;test&quot; , [ ] ) { :ok , &quot;test&quot; , 0 } iex(4)&gt; MeshxRpc.Protocol.Default . deserialize ( bin , [ ] , ser_flag ) { :ok , &quot;test&quot; }","ref":"MeshxRpc.Protocol.Default.html#serialize/2","title":"MeshxRpc.Protocol.Default.serialize/2","type":"function"},{"doc":"Convenience module on top of MeshxRpc.Server.Pool . Module leverages Kernel.use/2 macro to simplify user interaction with MeshxRpc.Server.Pool module: current module name is used as pool id, pool options can be specified with use/2 clause. Please refer to MeshxRpc.Server.Pool documentation for details. Example RPC server module: # lib/server.ex defmodule Example1.Server do use MeshxRpc.Server , address : { :tcp , { 127 , 0 , 0 , 1 } , 12_345 } , telemetry_prefix : [ :example1 , __MODULE__ ] , timeout_execute : 15_000 def echo ( args ) , do : call ( :echo , args ) def raise_test ( args ) , do : raise ( args ) end Start with application supervisor: # lib/example1/application.ex def start ( _type , _args ) do Supervisor . start_link ( [ Example1.Server ] , strategy : :one_for_one , name : Example1.Supervisor ) end","ref":"MeshxRpc.Server.html","title":"MeshxRpc.Server","type":"behaviour"},{"doc":"Returns a specification to start a RPC server workers pool under a supervisor.","ref":"MeshxRpc.Server.html#c:child_spec/1","title":"MeshxRpc.Server.child_spec/1","type":"callback"},{"doc":"RPC server workers pool. Configuration RPC server pool is configured with opts argument in child_spec/2 function. Configuration options common to both RPC client and server are described in MeshxRpc &quot;Common configuration&quot; section. Configuration options specific to RPC server opts argument in child_spec/2 : :timeout_execute - request function execution timeout, milliseconds. If timeout is exceeded request function is killed and remote RPC client call will error with: {:error_rpc, :killed} . The default value is :infinity .","ref":"MeshxRpc.Server.Pool.html","title":"MeshxRpc.Server.Pool","type":"module"},{"doc":"Returns a specification to start a RPC server workers pool under a supervisor. id is a pool id which should be a name of a module implementing user RPC functions. opts are options described in &quot;Configuration&quot; section above and in MeshxRpc &quot;Common configuration&quot; section. iex(1)&gt; MeshxRpc.Server.Pool . child_spec ( Example1.Server , address : { :uds , &quot;/tmp/meshx.sock&quot; } ) %{ id : { :ranch_embedded_sup , Example1.Server } , start : { :ranch_embedded_sup , :start_link , [ Example1.Server , :ranch_tcp , %{ socket_opts : [ ip : { :local , &quot;/tmp/meshx.sock&quot; } , port : 0 ] } , MeshxRpc.Server.Pool , [ ... ] ] } , type : :supervisor }","ref":"MeshxRpc.Server.Pool.html#child_spec/2","title":"MeshxRpc.Server.Pool.child_spec/2","type":"function"},{"doc":"MeshxRpc TCP protocol MeshxRpc is build on top of custom binary TCP protocol: two-step handshake, ... todo: Documentation will be provided at a later date. Screenshot showing protocol messages overview:","ref":"protocol.html","title":"MeshxRpc TCP protocol","type":"extras"}]